ServerEvents.recipes(event => {
    event.remove({id: 'rftoolsbase:machine_frame'})
    event.remove({id: 'xnet:controller'})
    event.remove({id: 'xnet:connector_yellow'})
    event.remove({id: 'xnet:connector_red'})
    event.remove({id: 'xnet:connector_green'})
    event.remove({id: 'xnet:connector_blue'})
    event.remove({id: 'xnet:advanced_connector_yellow'})
    event.remove({id: 'xnet:advanced_connector_red'})
    event.remove({id: 'xnet:advanced_connector_green'})
    event.remove({id: 'xnet:advanced_connector_blue'})
    event.remove({id: 'xnet:advanced_connector_routing'})
    event.remove({id: 'xnet:connector_upgrade'})
    event.remove({id: 'rftoolsdim:empty_dimension_tab'})
    event.remove({id: 'rftoolsdim:enscriber'})
    event.remove({id: 'rftoolsdim:dimlet_workbench'})
    event.remove({id: 'rftoolsdim:knowledge_holder'})
    event.remove({id: 'rftoolsdim:researcher'})
    event.remove({id: 'rftoolsdim:dimension_editor'})
    event.remove({id: 'rftoolsdim:dimension_builder'})
    event.remove({id: 'rftoolsbuilder:builder'})
})

ServerEvents.recipes(event => {
    //Machine Frame   
    event.recipes.botania.runic_altar("rftoolsbase:machine_frame", ["industrialforegoing:machine_frame_supreme", "rftoolsbase:machine_base", "rftoolsbase:machine_base"], 10000)

    //Inventory Scanner
    event.shaped('rftoolsstorage:storage_scanner',
    ['121','343','121'], {
    1: 'minecraft:redstone_torch',
    2: '#forge:ender_pearls',
    3: 'deeperdarker:reinforced_echo_shard',
    4: 'ars_nouveau:storage_lectern'
    }).id('rftoolsstorage:storage_scanner')

    //Builder
    event.shaped('rftoolsbuilder:builder',
      ['121','343','131'], {
      1: '#forge:plastic',
      2: '#forge:ender_pearls',
      3: '#forge:storage_blocks/compressed_iron',
      4: 'industrialforegoing:machine_frame_simple'
    }).id('rftoolsbuilder:builder')

    //Xnet Controller
    event.shaped('xnet:controller',
    ['121','343','565'], {
    1: 'minecraft:repeater',
    2: 'minecraft:comparator',
    3: '#forge:ingots/redstone_ingot',
    4: 'thermal:machine_frame',
	  5: '#forge:ingots/compressed_iron',
    6: '#forge:ingots/signalum'
    }).id('xnet:controller')

    //Xnet Blue Connector
    event.shaped('xnet:connector_blue',
    ['121','343','131'], {
    1: 'pneumaticcraft:glycerol',
    2: '#forge:chests/wooden',
    3: '#forge:ingots/redstone_ingot',
    4: '#forge:ingots/rose_gold'
    }).id('xnet:connector_blue')

    //Xnet Advanced Blue Connector
    event.shaped('xnet:advanced_connector_blue',
    ['12 ','34 ','   '], {
    1: '#xnet:connectors',
    2: '#forge:ingots/enderium',
    3: '#forge:gems/shadow_gem',
    4: '#forge:ingots/redstone_ingot'
    }).id('xnet:advanced_connector_blue')

    //Xnet Connector Upgrade
    event.shaped('xnet:connector_upgrade',
    ['12 ','34 ','   '], {
    1: '#xnet:connectors',
    2: '#forge:ingots/enderium',
    3: '#forge:gems/shadow_gem',
    4: '#forge:ingots/redstone_ingot'
    }).id('xnet:connector_upgrade')

    //Machine Base
    event.shaped('rftoolsbase:machine_base',
    ['   ','121','333'], {
    1: '#forge:ingots/blutonium',
    2: 'pneumaticcraft:printed_circuit_board',
    3: 'immersiveengineering:slab_sheetmetal_steel'
    }).id('rftoolsbase:machine_base')

    //Empty Dimension Tab
    event.custom({
      "type": "extendedcrafting:combination",
      "powerCost": 100000,
      "input": {
        "item": "botania:astrolabe"
      },
      "ingredients": [
        {
          "item": "allthecompressed:stone_2x"
        },
        {
          "item": "allthecompressed:end_stone_2x"
        },
        {
          "item": "allthecompressed:emerald_block_2x"
        },
        {
          "item": "allthecompressed:gravel_2x"
        },
        {
          "item": "allthecompressed:diamond_block_2x"
        },
        {
          "item": "allthecompressed:sand_2x"
        },
        {
          "item": "allthecompressed:dirt_2x"
        },
        {
          "item": "allthecompressed:netherrack_2x"
        }
      ],
      "result": {
        "item": "rftoolsdim:empty_dimension_tab"
      }
    }).id('rftoolsdim:empty_dimension_tab')

    //Enscriber
    event.custom({
      "type": "extendedcrafting:shaped_table",
      "pattern": [
        " A ",
        "ABA",
        " A "
      ],
      "key": {
        "A": {
          "item": "minecraft:paper"
        },
        "B": {
          "item": "rftoolsbase:dimensionalshard"
        }
      },
      "result": {
        "item": "rftoolsdim:enscriber"
      }
    }).id('rftoolsdim:enscriber')

    //Dimlet Workbench
    event.custom({
      "type": "extendedcrafting:shaped_table",
      "pattern": [
        "ABCBA",
        "DEFED",
        "CFGFC",
        "DEFED",
        "ABCBA"
      ],
      "key": {
        "A": {
          "item": "extrastorage:diamond_crafter"
        },
        "B": {
          "item": "rsinfinitybooster:dimension_card"
        },
        "C": {
          "item": "extrastorage:netherite_crafter"
        },
        "D": {
          "item": "rftoolsdim:empty_dimlet"
        },
        "E": {
          "item": "extrastorage:gold_crafter"
        },
        "F": {
          "item": "extrastorage:iron_crafter"
        },
        "G": {
          "item": "rftoolsbase:machine_frame"
        }
      },
      "result": {
        "item": "rftoolsdim:dimlet_workbench"
      }
    }).id('rftoolsdim:dimlet_workbench')

    //Knowledge Holder
    event.custom({
      "type": "extendedcrafting:shaped_table",
      "pattern": [
        "AAAAA",
        "ABCBA",
        "ACDCA",
        "ABCBA",
        "AAAAA"
      ],
      "key": {
        "A": {
          "item": "rftoolsbase:dimensionalshard"
        },
        "B": {
          "type": "forge:nbt",
          "item": "sophisticatedstorage:netherite_chest",
          "count": 1,
          "nbt": "{woodType:\"oak\"}"
        },
        "C": {
          "item": "mekanism_extras:infinite_control_circuit"
        },
        "D": {
          "item": "rftoolsbase:machine_frame"
        }
      },
      "result": {
        "item": "rftoolsdim:knowledge_holder"
      }
    }).id('rftoolsdim:knowledge_holder')

    //Researcher
    event.custom({
      "type": "extendedcrafting:shaped_table",
      "pattern": [
        "ABCBA",
        "DEFED",
        "GFHFG",
        "DIIID",
        "ABCBA"
      ],
      "key": {
        "A": {
          "item": "extendedcrafting:ultimate_component"
        },
        "B": {
          "item": "extendedcrafting:basic_component"
        },
        "C": {
          "item": "extendedcrafting:ultimate_catalyst"
        },
        "D": {
          "item": "extendedcrafting:elite_component"
        },
        "E": {
          "item": "mekanism_extras:infinite_control_circuit"
        },
        "F": {
          "item": "allthecompressed:redstone_block_3x"
        },
        "G": {
          "item": "extendedcrafting:advanced_component"
        },
        "H": {
          "item": "rftoolsbase:machine_frame"
        },
        "I": {
          "item": "rftoolsbase:machine_base"
        }
      },
      "result": {
        "item": "rftoolsdim:researcher"
      }
    }).id('rftoolsdim:researcher')

    //Dimension Editor
    event.custom({
      "type": "extendedcrafting:shaped_table",
      "pattern": [
        "AAAAAAA",
        "ABCDCBA",
        "ACEFECA",
        "AGFHFGA",
        "ACEFECA",
        "ABCDCBA",
        "AAAAAAA"
      ],
      "key": {
        "A": {
          "item": "rftoolsbase:dimensionalshard"
        },
        "B": {
          "item": "thermal:machine_frame"
        },
        "C": {
          "item": "mekanism_extras:infinite_control_circuit"
        },
        "D": {
          "item": "rftoolsbase:machine_frame"
        },
        "E": {
          "item": "industrialforegoing:machine_frame_supreme"
        },
        "F": {
          "item": "mekanism:steel_casing"
        },
        "G": {
          "item": "refinedstorage:machine_casing"
        },
        "H": {
          "item": "powah:dielectric_casing"
        }
      },
      "result": {
        "item": "rftoolsdim:dimension_editor"
      }
    }).id('rftoolsdim:dimension_editor')

    //Dimension Builder
    event.custom({
      "type": "extendedcrafting:shaped_table",
      "pattern": [
        "ABBBA",
        "CDEDC",
        "FGHIF",
        "JDKDJ",
        "LMMMN"
      ],
      "key": {
        "A": {
          "item": "kubejs:mystian_blossom"
        },
        "B": {
          "item": "allthecompressed:dirt_8x"
        },
        "C": {
          "item": "allthecompressed:sand_8x"
        },
        "D": {
          "item": "mekanism_extras:infinite_control_circuit"
        },
        "E": {
          "type": "forge:nbt",
          "item": "extendedcrafting:singularity",
          "count": 1,
          "nbt": "{Id:\"extendedcrafting:earth_gem\"}"
        },
        "F": {
          "item": "allthecompressed:gravel_8x"
        },
        "G": {
          "type": "forge:nbt",
          "item": "extendedcrafting:singularity",
          "count": 1,
          "nbt": "{Id:\"extendedcrafting:water_gem\"}"
        },
        "H": {
          "item": "rftoolsdim:dimension_editor"
        },
        "I": {
          "type": "forge:nbt",
          "item": "extendedcrafting:singularity",
          "count": 1,
          "nbt": "{Id:\"extendedcrafting:fire_gem\"}"
        },
        "J": {
          "item": "allthecompressed:netherrack_8x"
        },
        "K": {
          "type": "forge:nbt",
          "item": "extendedcrafting:singularity",
          "count": 1,
          "nbt": "{Id:\"extendedcrafting:air_gem\"}"
        },
        "L": {
          "item": "mysticalagradditions:creative_essence"
        },
        "M": {
          "item": "allthecompressed:end_stone_8x"
        },
        "N": {
          "item": "kubejs:ultimate_honeycomb"
        }
      },
      "result": {
        "item": "rftoolsdim:dimension_builder"
      }
    }).id('rftoolsdim:dimension_builder')
	
})